# coding: utf-8

"""
    Collibra Import API

    <p>The Import API is an efficient way to load large volumes of data into the Collibra Data Governance Center. The API can automatically differentiate between creating and updating data.</p>  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from collibra_importer import schemas  # noqa: F401


class ImportJsonInJobRequest(
    schemas.ComposedBase,
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    The request defining import call properties from a JSON file.
    """


    class MetaOapg:
        
        class properties:
            sendNotification = schemas.BoolSchema
            
            
            class batchSize(
                schemas.Int64Schema
            ):
            
            
                class MetaOapg:
                    format = 'int64'
                    inclusive_minimum = 1
            simulation = schemas.BoolSchema
            saveResult = schemas.BoolSchema
            fileId = schemas.UUIDSchema
            file = schemas.BinarySchema
            fileName = schemas.StrSchema
            deleteFile = schemas.BoolSchema
            continueOnError = schemas.BoolSchema
            
            
            class relationsAction(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    regex=[{
                        'pattern': r'ADD_OR_IGNORE|REPLACE',  # noqa: E501
                    }]
            __annotations__ = {
                "sendNotification": sendNotification,
                "batchSize": batchSize,
                "simulation": simulation,
                "saveResult": saveResult,
                "fileId": fileId,
                "file": file,
                "fileName": fileName,
                "deleteFile": deleteFile,
                "continueOnError": continueOnError,
                "relationsAction": relationsAction,
            }
        
        @classmethod
        @functools.lru_cache()
        def any_of(cls):
            # we need this here to make our import statements work
            # we must store _composed_schemas in here so the code is only run
            # when we invoke this method. If we kept this at the class
            # level we would get an error because the class level
            # code would be run when this module is imported, and these composed
            # classes don't exist yet because their module has not finished
            # loading
            return [
                CommunityImportCommand,
                DomainImportCommand,
                AssetImportCommand,
                MappingImportCommand,
                ComplexRelationImportCommand,
            ]

    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sendNotification"]) -> MetaOapg.properties.sendNotification: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["batchSize"]) -> MetaOapg.properties.batchSize: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["simulation"]) -> MetaOapg.properties.simulation: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["saveResult"]) -> MetaOapg.properties.saveResult: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileId"]) -> MetaOapg.properties.fileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["file"]) -> MetaOapg.properties.file: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileName"]) -> MetaOapg.properties.fileName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["deleteFile"]) -> MetaOapg.properties.deleteFile: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["continueOnError"]) -> MetaOapg.properties.continueOnError: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["relationsAction"]) -> MetaOapg.properties.relationsAction: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["sendNotification", "batchSize", "simulation", "saveResult", "fileId", "file", "fileName", "deleteFile", "continueOnError", "relationsAction", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sendNotification"]) -> typing.Union[MetaOapg.properties.sendNotification, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["batchSize"]) -> typing.Union[MetaOapg.properties.batchSize, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["simulation"]) -> typing.Union[MetaOapg.properties.simulation, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["saveResult"]) -> typing.Union[MetaOapg.properties.saveResult, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileId"]) -> typing.Union[MetaOapg.properties.fileId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["file"]) -> typing.Union[MetaOapg.properties.file, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileName"]) -> typing.Union[MetaOapg.properties.fileName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["deleteFile"]) -> typing.Union[MetaOapg.properties.deleteFile, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["continueOnError"]) -> typing.Union[MetaOapg.properties.continueOnError, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["relationsAction"]) -> typing.Union[MetaOapg.properties.relationsAction, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["sendNotification", "batchSize", "simulation", "saveResult", "fileId", "file", "fileName", "deleteFile", "continueOnError", "relationsAction", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        sendNotification: typing.Union[MetaOapg.properties.sendNotification, bool, schemas.Unset] = schemas.unset,
        batchSize: typing.Union[MetaOapg.properties.batchSize, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        simulation: typing.Union[MetaOapg.properties.simulation, bool, schemas.Unset] = schemas.unset,
        saveResult: typing.Union[MetaOapg.properties.saveResult, bool, schemas.Unset] = schemas.unset,
        fileId: typing.Union[MetaOapg.properties.fileId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        file: typing.Union[MetaOapg.properties.file, bytes, io.FileIO, io.BufferedReader, schemas.Unset] = schemas.unset,
        fileName: typing.Union[MetaOapg.properties.fileName, str, schemas.Unset] = schemas.unset,
        deleteFile: typing.Union[MetaOapg.properties.deleteFile, bool, schemas.Unset] = schemas.unset,
        continueOnError: typing.Union[MetaOapg.properties.continueOnError, bool, schemas.Unset] = schemas.unset,
        relationsAction: typing.Union[MetaOapg.properties.relationsAction, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ImportJsonInJobRequest':
        return super().__new__(
            cls,
            *args,
            sendNotification=sendNotification,
            batchSize=batchSize,
            simulation=simulation,
            saveResult=saveResult,
            fileId=fileId,
            file=file,
            fileName=fileName,
            deleteFile=deleteFile,
            continueOnError=continueOnError,
            relationsAction=relationsAction,
            _configuration=_configuration,
            **kwargs,
        )

from collibra_importer.model.asset_import_command import AssetImportCommand
from collibra_importer.model.community_import_command import CommunityImportCommand
from collibra_importer.model.complex_relation_import_command import ComplexRelationImportCommand
from collibra_importer.model.domain_import_command import DomainImportCommand
from collibra_importer.model.mapping_import_command import MappingImportCommand
