# coding: utf-8

"""
    Collibra Import API

    <p>The Import API is an efficient way to load large volumes of data into the Collibra Data Governance Center. The API can automatically differentiate between creating and updating data.</p>  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from collibra_importer import schemas  # noqa: F401


class SynchronizationExcelInJobRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    The request defining synchronization call properties from a Excel file.
    """


    class MetaOapg:
        required = {
            "template",
            "synchronizationId",
        }
        
        class properties:
            
            
            class synchronizationId(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    max_length = 50
                    min_length = 1
            template = schemas.StrSchema
            sendNotification = schemas.BoolSchema
            
            
            class batchSize(
                schemas.Int64Schema
            ):
            
            
                class MetaOapg:
                    format = 'int64'
                    inclusive_minimum = 1
            simulation = schemas.BoolSchema
            saveResult = schemas.BoolSchema
            fileId = schemas.UUIDSchema
            file = schemas.BinarySchema
            fileName = schemas.StrSchema
            deleteFile = schemas.BoolSchema
            continueOnError = schemas.BoolSchema
            sheetName = schemas.StrSchema
            sheetIndex = schemas.Int32Schema
            headerRow = schemas.BoolSchema
            __annotations__ = {
                "synchronizationId": synchronizationId,
                "template": template,
                "sendNotification": sendNotification,
                "batchSize": batchSize,
                "simulation": simulation,
                "saveResult": saveResult,
                "fileId": fileId,
                "file": file,
                "fileName": fileName,
                "deleteFile": deleteFile,
                "continueOnError": continueOnError,
                "sheetName": sheetName,
                "sheetIndex": sheetIndex,
                "headerRow": headerRow,
            }
    
    template: MetaOapg.properties.template
    synchronizationId: MetaOapg.properties.synchronizationId
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["synchronizationId"]) -> MetaOapg.properties.synchronizationId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["template"]) -> MetaOapg.properties.template: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sendNotification"]) -> MetaOapg.properties.sendNotification: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["batchSize"]) -> MetaOapg.properties.batchSize: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["simulation"]) -> MetaOapg.properties.simulation: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["saveResult"]) -> MetaOapg.properties.saveResult: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileId"]) -> MetaOapg.properties.fileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["file"]) -> MetaOapg.properties.file: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileName"]) -> MetaOapg.properties.fileName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["deleteFile"]) -> MetaOapg.properties.deleteFile: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["continueOnError"]) -> MetaOapg.properties.continueOnError: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sheetName"]) -> MetaOapg.properties.sheetName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sheetIndex"]) -> MetaOapg.properties.sheetIndex: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["headerRow"]) -> MetaOapg.properties.headerRow: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["synchronizationId", "template", "sendNotification", "batchSize", "simulation", "saveResult", "fileId", "file", "fileName", "deleteFile", "continueOnError", "sheetName", "sheetIndex", "headerRow", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["synchronizationId"]) -> MetaOapg.properties.synchronizationId: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["template"]) -> MetaOapg.properties.template: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sendNotification"]) -> typing.Union[MetaOapg.properties.sendNotification, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["batchSize"]) -> typing.Union[MetaOapg.properties.batchSize, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["simulation"]) -> typing.Union[MetaOapg.properties.simulation, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["saveResult"]) -> typing.Union[MetaOapg.properties.saveResult, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileId"]) -> typing.Union[MetaOapg.properties.fileId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["file"]) -> typing.Union[MetaOapg.properties.file, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileName"]) -> typing.Union[MetaOapg.properties.fileName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["deleteFile"]) -> typing.Union[MetaOapg.properties.deleteFile, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["continueOnError"]) -> typing.Union[MetaOapg.properties.continueOnError, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sheetName"]) -> typing.Union[MetaOapg.properties.sheetName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sheetIndex"]) -> typing.Union[MetaOapg.properties.sheetIndex, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["headerRow"]) -> typing.Union[MetaOapg.properties.headerRow, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["synchronizationId", "template", "sendNotification", "batchSize", "simulation", "saveResult", "fileId", "file", "fileName", "deleteFile", "continueOnError", "sheetName", "sheetIndex", "headerRow", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        template: typing.Union[MetaOapg.properties.template, str, ],
        synchronizationId: typing.Union[MetaOapg.properties.synchronizationId, str, ],
        sendNotification: typing.Union[MetaOapg.properties.sendNotification, bool, schemas.Unset] = schemas.unset,
        batchSize: typing.Union[MetaOapg.properties.batchSize, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        simulation: typing.Union[MetaOapg.properties.simulation, bool, schemas.Unset] = schemas.unset,
        saveResult: typing.Union[MetaOapg.properties.saveResult, bool, schemas.Unset] = schemas.unset,
        fileId: typing.Union[MetaOapg.properties.fileId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        file: typing.Union[MetaOapg.properties.file, bytes, io.FileIO, io.BufferedReader, schemas.Unset] = schemas.unset,
        fileName: typing.Union[MetaOapg.properties.fileName, str, schemas.Unset] = schemas.unset,
        deleteFile: typing.Union[MetaOapg.properties.deleteFile, bool, schemas.Unset] = schemas.unset,
        continueOnError: typing.Union[MetaOapg.properties.continueOnError, bool, schemas.Unset] = schemas.unset,
        sheetName: typing.Union[MetaOapg.properties.sheetName, str, schemas.Unset] = schemas.unset,
        sheetIndex: typing.Union[MetaOapg.properties.sheetIndex, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        headerRow: typing.Union[MetaOapg.properties.headerRow, bool, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'SynchronizationExcelInJobRequest':
        return super().__new__(
            cls,
            *args,
            template=template,
            synchronizationId=synchronizationId,
            sendNotification=sendNotification,
            batchSize=batchSize,
            simulation=simulation,
            saveResult=saveResult,
            fileId=fileId,
            file=file,
            fileName=fileName,
            deleteFile=deleteFile,
            continueOnError=continueOnError,
            sheetName=sheetName,
            sheetIndex=sheetIndex,
            headerRow=headerRow,
            _configuration=_configuration,
            **kwargs,
        )
