# coding: utf-8

"""
    Collibra Import API

    <p>The Import API is an efficient way to load large volumes of data into the Collibra Data Governance Center. The API can automatically differentiate between creating and updating data.</p>  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from collibra_importer import schemas  # noqa: F401


class SynchronizationJsonInJobRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    The request defining synchronization call properties from a JSON file.
    """


    class MetaOapg:
        required = {
            "synchronizationId",
        }
        
        class properties:
            
            
            class synchronizationId(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    max_length = 50
                    min_length = 1
            sendNotification = schemas.BoolSchema
            
            
            class batchSize(
                schemas.Int64Schema
            ):
            
            
                class MetaOapg:
                    format = 'int64'
                    inclusive_minimum = 1
            simulation = schemas.BoolSchema
            saveResult = schemas.BoolSchema
            fileId = schemas.UUIDSchema
            file = schemas.BinarySchema
            fileName = schemas.StrSchema
            deleteFile = schemas.BoolSchema
            continueOnError = schemas.BoolSchema
            
            
            class finalizationStrategy(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    regex=[{
                        'pattern': r'REMOVE_RESOURCES|CHANGE_STATUS|IGNORE',  # noqa: E501
                    }]
            
            
            class finalizationParameters(
                schemas.DictSchema
            ):
            
            
                class MetaOapg:
                    additional_properties = schemas.StrSchema
                
                def __getitem__(self, name: typing.Union[str, ]) -> MetaOapg.additional_properties:
                    # dict_instance[name] accessor
                    return super().__getitem__(name)
                
                def get_item_oapg(self, name: typing.Union[str, ]) -> MetaOapg.additional_properties:
                    return super().get_item_oapg(name)
            
                def __new__(
                    cls,
                    *args: typing.Union[dict, frozendict.frozendict, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                    **kwargs: typing.Union[MetaOapg.additional_properties, str, ],
                ) -> 'finalizationParameters':
                    return super().__new__(
                        cls,
                        *args,
                        _configuration=_configuration,
                        **kwargs,
                    )
            missingAssetStatusId = schemas.UUIDSchema
            
            
            class relationsAction(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    regex=[{
                        'pattern': r'ADD_OR_IGNORE|REPLACE',  # noqa: E501
                    }]
            __annotations__ = {
                "synchronizationId": synchronizationId,
                "sendNotification": sendNotification,
                "batchSize": batchSize,
                "simulation": simulation,
                "saveResult": saveResult,
                "fileId": fileId,
                "file": file,
                "fileName": fileName,
                "deleteFile": deleteFile,
                "continueOnError": continueOnError,
                "finalizationStrategy": finalizationStrategy,
                "finalizationParameters": finalizationParameters,
                "missingAssetStatusId": missingAssetStatusId,
                "relationsAction": relationsAction,
            }
    
    synchronizationId: MetaOapg.properties.synchronizationId
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["synchronizationId"]) -> MetaOapg.properties.synchronizationId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sendNotification"]) -> MetaOapg.properties.sendNotification: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["batchSize"]) -> MetaOapg.properties.batchSize: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["simulation"]) -> MetaOapg.properties.simulation: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["saveResult"]) -> MetaOapg.properties.saveResult: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileId"]) -> MetaOapg.properties.fileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["file"]) -> MetaOapg.properties.file: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileName"]) -> MetaOapg.properties.fileName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["deleteFile"]) -> MetaOapg.properties.deleteFile: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["continueOnError"]) -> MetaOapg.properties.continueOnError: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["finalizationStrategy"]) -> MetaOapg.properties.finalizationStrategy: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["finalizationParameters"]) -> MetaOapg.properties.finalizationParameters: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["missingAssetStatusId"]) -> MetaOapg.properties.missingAssetStatusId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["relationsAction"]) -> MetaOapg.properties.relationsAction: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["synchronizationId", "sendNotification", "batchSize", "simulation", "saveResult", "fileId", "file", "fileName", "deleteFile", "continueOnError", "finalizationStrategy", "finalizationParameters", "missingAssetStatusId", "relationsAction", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["synchronizationId"]) -> MetaOapg.properties.synchronizationId: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sendNotification"]) -> typing.Union[MetaOapg.properties.sendNotification, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["batchSize"]) -> typing.Union[MetaOapg.properties.batchSize, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["simulation"]) -> typing.Union[MetaOapg.properties.simulation, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["saveResult"]) -> typing.Union[MetaOapg.properties.saveResult, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileId"]) -> typing.Union[MetaOapg.properties.fileId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["file"]) -> typing.Union[MetaOapg.properties.file, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileName"]) -> typing.Union[MetaOapg.properties.fileName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["deleteFile"]) -> typing.Union[MetaOapg.properties.deleteFile, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["continueOnError"]) -> typing.Union[MetaOapg.properties.continueOnError, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["finalizationStrategy"]) -> typing.Union[MetaOapg.properties.finalizationStrategy, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["finalizationParameters"]) -> typing.Union[MetaOapg.properties.finalizationParameters, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["missingAssetStatusId"]) -> typing.Union[MetaOapg.properties.missingAssetStatusId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["relationsAction"]) -> typing.Union[MetaOapg.properties.relationsAction, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["synchronizationId", "sendNotification", "batchSize", "simulation", "saveResult", "fileId", "file", "fileName", "deleteFile", "continueOnError", "finalizationStrategy", "finalizationParameters", "missingAssetStatusId", "relationsAction", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        synchronizationId: typing.Union[MetaOapg.properties.synchronizationId, str, ],
        sendNotification: typing.Union[MetaOapg.properties.sendNotification, bool, schemas.Unset] = schemas.unset,
        batchSize: typing.Union[MetaOapg.properties.batchSize, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        simulation: typing.Union[MetaOapg.properties.simulation, bool, schemas.Unset] = schemas.unset,
        saveResult: typing.Union[MetaOapg.properties.saveResult, bool, schemas.Unset] = schemas.unset,
        fileId: typing.Union[MetaOapg.properties.fileId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        file: typing.Union[MetaOapg.properties.file, bytes, io.FileIO, io.BufferedReader, schemas.Unset] = schemas.unset,
        fileName: typing.Union[MetaOapg.properties.fileName, str, schemas.Unset] = schemas.unset,
        deleteFile: typing.Union[MetaOapg.properties.deleteFile, bool, schemas.Unset] = schemas.unset,
        continueOnError: typing.Union[MetaOapg.properties.continueOnError, bool, schemas.Unset] = schemas.unset,
        finalizationStrategy: typing.Union[MetaOapg.properties.finalizationStrategy, str, schemas.Unset] = schemas.unset,
        finalizationParameters: typing.Union[MetaOapg.properties.finalizationParameters, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        missingAssetStatusId: typing.Union[MetaOapg.properties.missingAssetStatusId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        relationsAction: typing.Union[MetaOapg.properties.relationsAction, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'SynchronizationJsonInJobRequest':
        return super().__new__(
            cls,
            *args,
            synchronizationId=synchronizationId,
            sendNotification=sendNotification,
            batchSize=batchSize,
            simulation=simulation,
            saveResult=saveResult,
            fileId=fileId,
            file=file,
            fileName=fileName,
            deleteFile=deleteFile,
            continueOnError=continueOnError,
            finalizationStrategy=finalizationStrategy,
            finalizationParameters=finalizationParameters,
            missingAssetStatusId=missingAssetStatusId,
            relationsAction=relationsAction,
            _configuration=_configuration,
            **kwargs,
        )
